local addon, _ = ... 

-- saved emoticons
local SEtabs = {
   [1] = {
	  ["tabName"] = "p1",
	  ["scrollNumX"] = 5,
	  ["buttonSize"] = {40, 25},
	  ["line"] = 1,
	  ["contents"] = {
		 ":)", ";-)", ":D", ":P", ":(", ":'(",
		 ":-)", ":S", ":O", "B-)", "o_O", "^O^",
		 "T_T", "-.-", "^_^", "~_~", "-_-", ">_<",
		 ">.<", "=.=", "=.=!", "╰_╯", "-_-z", "@_@",
		 "囧rz", "Orz", "^_-", "→_→", "←_←", "Orz",
		 "≧◇≦", "(x_x)", "∩__∩",
	  },
   },
   [2] = {
	  ["tabName"] = "p2",
	  ["scrollNumX"] = 3,
	  ["buttonSize"] = {85, 25},
	  ["line"] = 1,
	  ["contents"] = {
		 "⊙▽⊙", "⊙△⊙", "⊙﹏⊙",
		 "(⊙ｏ⊙)", "(⊙ｏ⊙)", "︽⊙＿⊙︽",
		 "(︶^︶)", "^(oo)^", "'=^_^=", "\\^o^/", "（ˇ_ˇ）", "（°ο°）",
		 "└(^o^)┘", "~w_w~", "::>_<:: ", "↖(^ω^)↗", "o(︶︿︶)o",
		 "ㄟ(￣▽￣ㄟ)", "(=θωθ=)", "o(≧o≦)o", "(￣(工)￣)",
		 "↖(￣▽￣)", "(*@?@*)", "//(ㄒoㄒ)//", "(*>.<*)",
	  },
   },
   [3] = {
	  ["tabName"] = "komica",
	  ["scrollNumX"] = 4,
	  ["buttonSize"] = {85, 25},
	  ["line"] = 1,
	  ["contents"] = {
		 "(´ﾟДﾟ`)", "(;´Д`)", "(｀･ω･)", "(=ﾟωﾟ)=", "| ω・´)",
		 "| ω・`)", "|-` )", "|дﾟ )ﾉ", "| V ﾟ )ﾉ", "|д` )", "|ー` )",
		 "|V` )", "|Vﾟ )","(ﾟДﾟ≡ﾟДﾟ)", "(＾o＾)ﾉ",
		 "(|||ﾟДﾟ)", "( ﾟVﾟ)", "( ´V`)", "(*´V`)", 
		 "(*´д`)", "(*ﾟーﾟ)", "(　ﾟ 3ﾟ)", "( ´ー`)", "( ・_ゝ・)",
		 "( ´_ゝ`)", "(・ー・)", "(・V・)", "(ゝV･)", "(〃V〃)",
		 "(*ﾟVﾟ*)", "( ﾟV。)", "( `д´)", "(`ε´ )",
		 "(`ヮ´ )", "σ`V´)", " ﾟVﾟ)σ", "ﾟ Vﾟ)ノ", "(╬ﾟдﾟ)",
		 "(|||ﾟдﾟ)", "(´ﾟдﾟ`)", "( ﾟдﾟ)", "Σ( ﾟдﾟ)", "( ;ﾟдﾟ)",
		 "( ;´д`)", "(　д ) ﾟ ﾟ", "( ☉д⊙)", "(((　ﾟдﾟ)))", "( ` ・´)",
		 "( ´д`)", "( -д-)", "(>д<)", "･ﾟ( ﾉд`ﾟ)",
		 "( TдT)", "(￣∇￣)", "(￣3￣)", "(￣ｰ￣)", "(￣ . ￣)",
		 "(￣皿￣)", "(￣艸￣)", "(￣︿￣)", "(￣︶￣)", "(≧▽≦)",
		 "ヾ(´ε`ヾ)", "(*´ω`*)", "(・ω・)", "(｀･ω･)",
		 "( ´・ω)", "(｀・ω)", "(´・ω・`)", "(`・ω・´)",
		 "( `_っ´)", "( `ー´)", "( ´_っ`)", "( ´ρ`)", "( ﾟωﾟ)",
		 "(oﾟωﾟo)", "( ^ω^)", "ヾ(´ε`ヾ)",
		 "(ノﾟVﾟ)ノ", "(σﾟдﾟ)σ", "(σﾟVﾟ)σ", "|д` )", "|ー` )", "|дﾟ )",
		 "|Vﾟ )", "ﾟ(つд`ﾟ)", "ﾟAﾟ)", "(´V((☆ミつ", 
		
	  },
   },
   [4] = {
	  ["tabName"] = "garble",
	  ["scrollNumX"] = 3,
	  ["buttonSize"] = {85, 25},
	  ["line"] = 1,
	  ["contents"] = {
		 "⊂彡☆))V`)", "(つд⊂)",
		 "⊂彡☆))д`)", "⊂彡☆))д´)",
		 "(｡◕∀◕｡)", "/( ◕‿‿◕ )\\",
	  },
   },
};

-- global 
local tabs = {};
local tabContents = {};
local SE = {
   highlight = false,
};
   
-- init functions
function InitToggleButton(frame)
   local button = CreateFrame("Button", "SimpleEmoticonsButton", UIParent, "UIPanelButtonTemplate");
   button:SetSize(20,23);
   button:SetText(" E");
   button:ClearAllPoints();
   button:SetPoint("BOTTOM", FriendsMicroButton, "TOP", 0, 10);
   button:SetMovable(true);
   button:SetScript("OnMouseDown",
				  function(self,button)
					 if (button=="LeftButton") then
						self:StartMoving();
					 end
				  end);
   button:SetScript("OnMouseUp",
				  function(self)
					 self:StopMovingOrSizing();
				  end);
   button:SetScript("OnClick",
					function()
					   if frame:IsVisible() then
						  frame:Hide();
					   else
						  frame:Show();
					   end
					end);
					
   return button;
end

function InitPages(frame)
   local tab;
   for k,v in ipairs(SEtabs) do
	  -- init tab button
	  tab = CreateFrame("Button", "SimpleEmoticonsTab"..k, frame,"SimpleEmoticonTabTemplate"); 
	  tab:SetID(k);
	  tab:SetText(v.tabName);
	  tab:SetSize(strlen(v.tabName)*7+15,32);
	  if (k > 1) then
		 tab:SetPoint("LEFT", tabs[k-1], "RIGHT");
	  else
		 tab:SetPoint("TOPLEFT", frame, "TOPLEFT");
	  end
	  
	  -- init tab content
	  local tabContent = CreateFrame("ScrollFrame", "SimpleEmoticonsTabContent"..k, frame, "SimpleEmoticonTabContentTemplate");
	  tabContent:SetID(k);
	  tabContent:SetPoint("LEFT", frame, "LEFT");
	  tabContent:SetPoint("TOP", tab, "BOTTOM");
	  tabContent:SetSize(v.scrollNumX * (v.buttonSize[1] + 10), 120);
	  local scrollChild = tabContent:GetScrollChild();
	  
	  -- init buttons in tabContent
	  local i = 1;
	  local lineFirst, lastButton = false;
	  for k2, v2 in ipairs(v.contents) do
		 local button;
		 if (v.line == 1) then
			button = CreateFrame("Button", nil, scrollChild, "SimpleEmoticonButtonTemplate");
		 else
			print("not line 1");
		 end
		 button:SetText(v2);
		 button:SetSize(unpack(v.buttonSize));
		 if ( i == 1 ) then -- new line
			if (lineFirst) then -- 2nd+ line
			   button:SetPoint("TOPLEFT", lineFirst, "BOTTOMLEFT");
			else -- 1st line
			   button:SetPoint("TOPLEFT", scrollChild, "TOPLEFT", 5, 0);
			end
			lineFirst = button;
			lastButton = lineFirst;
		 else -- in line
			button:SetPoint("LEFT", lastButton , "RIGHT", 10, 0);
			lastButton = button;
			i = i % v.scrollNumX;
		 end
		 i = i+1;
	  end
	  
	  -- save page in global
	  tabs[k] = tab;
	  tabContents[k] = tabContent;
   end
   
   InitChooseChannelButton(frame, tab);
end

function InitChooseChannelButton(frame, lastTab)
   local channels = {
	  -- [position] = { text, channel_code, tooltip}
	  [1] = {"say", "SAY",},
	  [2] = {"guild", "GUILD",},
	  [3] = {"instance", "INSTANCE_CHAT",},
	  [4] = {"party", "PARTY",},
	  [5] = {"raid", "RAID",},
	  [6] = {"yell", "YELL",},
	  -- [7] = {"whisper", "WHISPER",},
   };
   local button = CreateFrame("Button", "SimpleEmoticonChannelButton", frame, "UIPanelButtonTemplate");
   button:SetSize(70,25);
   button:SetPoint("LEFT", lastTab, "RIGHT");
   
   -- create dropdownmenu for button
   local menu = CreateFrame("Frame", "SimpleEmoticonChannelDropDownMenu", button, "UIDropDownMenuTemplate");
   menu:SetFrameStrata("FULLSCREEN_DIALOG");
   UIDropDownMenu_Initialize(menu,
							 function(self, level)
								local info;
								for i = 1, #channels do
								   info = UIDropDownMenu_CreateInfo();
								   info.text = channels[i][1];
								   info.value = channels[i][2];
								   info.func = ChooseChannel;
								   UIDropDownMenu_AddButton(info, level);
								end
							 end);
   -- set default channel
   if (IsInGuild()) then
         UIDropDownMenu_SetSelectedID(menu, 2);
         button.channel = channels[2][2];
         button:SetText("guild");
   else
         UIDropDownMenu_SetSelectedID(menu, 1);
         button.channel = channels[1][2];
         button:SetText("say");
   end
   
   function ChooseChannel(self)
	  UIDropDownMenu_SetSelectedID(menu, self:GetID());
	  button:SetText(self:GetText());
	  button.channel = self.value;
   end
   --
   button.menu = menu;
   
   button:SetScript("OnClick", 
					function() 
					   ToggleDropDownMenu(1, nil, menu, button:GetName(), -46, #channels * 20 + 35) 
					end);
end

function InitMain()
   local frame = CreateFrame("Frame", "SimpleEmoticonFrame", UIParent);
   local toggleButton = InitToggleButton(frame);
   frame:SetSize(1,160);
   frame:SetPoint("BOTTOMLEFT", toggleButton, "TOPLEFT", 0, 0);
   frame:Hide();
   InitPages(frame);
   tabChange(1);
end


-- click script
function tabChange(id)
   for k, v in ipairs(tabContents) do
	  if (k == id) then
		 v:Show();
		 tabs[k]:GetFontString():SetTextColor(1,0.8,0,1);
		 v:SetVerticalScroll(0);
	  else
		 v:Hide();
		 tabs[k]:GetFontString():SetTextColor(1,1,1,0.3);
	  end
   end
end

InitMain();

function sendEmoticonLine1(text)
   text = string.gsub(text, "|", "||");
   if (IsModifiedClick("CHATLINK")) then
	  SE_ChatEdit_InsertAndHighlight(text);
   else
	  SendChatMessage(text, SimpleEmoticonChannelButton.channel);
   end
end

-- modify the function ChatEdit_InsertLink(text)
-- the origin func can be found at : FrameXML/ChatFrame.lua

function SE_ChatEdit_InsertAndHighlight(text)
    if ( not text ) then
        return false;
    end
     
    local activeWindow = ChatEdit_GetActiveWindow();
    if ( activeWindow ) then
	   if (SE.highlight) then
		  -- add a space for proper parsing
		  text = " "..text;
		  local insertPos = activeWindow:GetCursorPosition();
		  local insertLen = strlen(text);
		  activeWindow:Insert(text);
		  activeWindow:HighlightText(insertPos, insertPos+insertLen);
		  return true;
	   else
		  activeWindow:Insert(" "..text);
	   end
    end
    return false;
end

-- slash command to reset
SLASH_SIMPLEEMOTICON1 = "/simpleemoticon";

SlashCmdList["SIMPLEEMOTICON"] = function(command)
   command = command:lower();
   if (command == 'reset') then
	  SimpleEmoticonsButton:ClearAllPoints();
	  SimpleEmoticonsButton:SetPoint("BOTTOM", FriendsMicroButton, "TOP", 0, 10);
   elseif (command == 'highlight' or command == 'hl') then
	  SE.highlight = not SE.highlight;
          print("Turned highlight to: |cffff1000",SE.highlight,"|r");
          --print("turn highlight to: |cffff1000"..val.."|r");
   else
	  print([[
simpleemocation usage:
/simpleemoticon |cffff1000reset|r
    |cfffff000reset the position of the button.|r
/simpleemoticon |cff0080ffhl|r
    |cfffff000when hl is true: auto select the content when shift-click.|r
]]);
   end
end
